/*
   wputils.c
   Copyright (c) 2000 by Stewart Wilkinson G0LGS
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>
#include <syslog.h>
#include <unistd.h>

#include "wputils.h"

int Check_Call(char *s)
{
   int len = 0;
   int nums = 0;
   char *t = s;

   if(t == (NULL) )
      return -1;

   while (*t) {
      *t = toupper(*t);
      if (!isalnum(*t))
         return -1;
      if (isdigit(*t))
         nums++;

      len++;
      t++;
   }

   if (len < 3 || len > 6 || !nums || nums > 2 )
      return 1;

   return 0;
}

int Check_Home(char *s)
{
   int  dots = 0;
   char allow[39] = "01234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ#.";
   char bbs_call[64];
   char *p;

   if (s == (NULL) )
      return -1;

   /* Check Callsign part (up to first dot) */
   strcpy(bbs_call, s);

   if( (p = strchr(bbs_call,'.') ) != NULL ){
      p[0] = '\0';

      if(Check_Call(bbs_call) != 0)
         return 1;
   }

   /* Must not have 2 dots together */
   if( strstr(s,"..") != NULL )
      return 2;

   while (*s) {

      if(!strchr(allow, *s))
         return 3;

      if(strchr(".", *s))
         dots++;

      s++;
   }

   /* Last char must not be a dot */
   s--;
   if( strcmp(s,".") == 0 )
      return 4;

   /* Must have at least 2 dots */
   if(dots < 2)
      return 5;

   return 0;
}



